Outline.SetTitle( "RSTAEgC" );	//AEgC̓^Cgݒ
Outline.SetListType( 100 );	//ėpc[


var depth = -1;				//[
var markStack = [];			//LX^bN
var line_max = Editor.GetLineCount( 0 );
var bofMark = Plugin.GetOption('RSTOutline', 'BOF');
var eofMark = Plugin.GetOption('RSTOutline', 'EOF');

//͔ԍłȂƔf镶
var filterLength = Plugin.GetOption('RSTOutline', 'filterLength');

if (bofMark != '') {
	Outline.AddFuncInfo2( 1, 1, bofMark, 0 );
}

if (filterLength == '' || filterLength < 1) {
	filterLength = 150;
}

var last_reg_line_no = 0;
function register(line_no, s, depth) {
	if (last_reg_line_no == line_no) return;
	last_reg_line_no = line_no;
	Outline.AddFuncInfo2(line_no, 1, s, depth);
}
function register_mark(line_no, pretty, mark) {
	if (markStack.length == 0) {
		depth++;
		register(line_no, pretty, depth);
		markStack.push(mark);
	} else {
		var idx;
		for (idx = markStack.length-1; idx >= 0 && markStack[idx] != mark; idx--) ;
		if (idx < 0) {
			depth++;
			register(line_no, pretty, depth);
			markStack.push(mark);
		} else {
			depth = idx;
			register(line_no, pretty, depth);
			markStack.splice(idx + 1, markStack.length);
		}
	}
}
var previousTitleString = '';
function register_title(line_no, pretty, mark) {
	if (last_reg_line_no == line_no) return;
	var p2 = pretty.toLowerCase();
	if (p2 == previousTitleString) return;
	previousTitleString = p2;
	markStack = [];
	depth = -1;
	register_mark(line_no, pretty, mark);
}

//ҏW1sǂݍŉ͂
var prev_indent;
var prev_pretty;
//RST͌oLs̏ɌoeLXg肻̏ɋsLsi܂̓t@C擪jȂ̂ł̔ɎgDȂƃe[uƌoĂ܂D
var pp_pretty="\n";
for ( var line_no = 1; line_no <= line_max; line_no++ ) {
	var line_str = Editor.GetLineStr( line_no );
	line_str = line_str.substr(0, line_str.length-1);	//EOL菜

	var pretty = line_str
	var indent = line_str.replace(/^([\s@]*).*/, "$1");

	pretty = pretty.substr(0, filterLength)

// L̗i2ȏAŋ󔒂ȂDӏ͕K󔒂̂łŋʁDjCオ󔒕łȂieLXg͂jCɏオŝ݁iline_no=0ŶƂ͏lŝ݂ǂނ̂TruejłTrue
	if  (line_no>1 && /^([=]{2,}|[-]{2,}|[`]{2,}|[:]{2,}|[']{2,}|["]{2,}|[~]{2,}|[\^]{2,}|[_]{2,}|[*]{2,}|[+]{2,}|[#]{2,}|[<]{2,}|[>]{2,}|D{2,}|B+)\n?\r?$/.test(pretty) && !/^[\s@]*\n?\r?$/.test(prev_pretty) && /^\n?\r?$/.test(pp_pretty) ) {
		register_mark(line_no - 1, prev_pretty, pretty.substr(0, 1));
	}

// Lɋ߂Ō̏sł͂Ȃpretty=pp_prettyiLň͂܂Ăj
	else if  (line_no>2 && /^([=]{2,}|[-]{2,}|[`]{2,}|[:]{2,}|[']{2,}|["]{2,}|[~]{2,}|[\^]{2,}|[_]{2,}|[*]{2,}|[+]{2,}|[#]{2,}|[<]{2,}|[>]{2,}|D{2,}|B+)\n?\r?$/.test(pretty) && !/^[\s@]*\n?\r?$/.test(prev_pretty) && pp_pretty == pretty  ) {
// register_markɑƂɈ͂݌^Ɖ^ʂł悤1Ă
		register_mark(line_no - 1, prev_pretty, pretty.substr(0, 1)+"1");
	}

	if (line_no>1){pp_pretty = prev_pretty};
	prev_indent = indent;
	prev_pretty = pretty;
	
}
if (eofMark != '') {
	register(line_max, eofMark, 0);
}

